#include "dispatch.h"
#include <stdlib.h>

Dispatch *
dispatch_new (void)
{
  Dispatch *self = malloc (sizeof (Dispatch));
  self->count    = 0;
  return self;
}

void       dispatch_add_task (Dispatch               *self,
                              int                     priority,
                              dispatch_task_init      init,
                              dispatch_task_iteration iteration,
                              dispatch_task_destroy   destroy,
                              void                   *data
                              )
{
  if (init)
    init (data);
  self->task_priority[self->count]  = priority;
  self->task_iteration[self->count] = iteration;
  self->task_data[self->count]      = data;
  self->task_destroy[self->count]   = destroy;
  self->count++;
}

void dispatch_add_idle (Dispatch                *self,
                        dispatch_task_iteration  iteration,
                        void                    *data)

{
  dispatch_add_task (self, 0, NULL, iteration, NULL, data);
}

int dispatch_iterate (Dispatch *self)
{
  int processed_a_task=0;
  int i;
  for (i=0; i<self->count; i++)
    {
      if (self->task_iteration[i])
        { 
          if (self->task_iteration[i](self->task_data[i]))
            {
              processed_a_task=1;
            }
          else
            {
              self->task_iteration[i] = NULL;
              if (self->task_destroy[i])
                {
                  self->task_destroy[i](self->task_data[i]);
                  self->task_destroy[i]=NULL;
                }
            }
        }
    }
  return processed_a_task;
}

void dispatch_destroy (Dispatch *self)
{
  int i;
  for (i=self->count-1; i>=0; i--)
    {
      if (self->task_destroy[i])
        {
           self->task_destroy[i](self->task_data[i]);
           self->task_iteration[i]=NULL;
           self->task_destroy[i]=NULL;
        }
    }
  free (self);
}
