/* image loading, and fast simple manipulation routines, when
 * larger needs arise, larger but more robust dependencies should
 * be considered
 */

#ifndef LOAD_IMAGE_H
#define LOAD_IMAGE_H

/* reuturns 0 on success non-zero on fail
 *
 * selects between formats based on extension,
 * already known formats: jpeg and png.
 *
 */
int
load_image (const char     *path,
            int            *width,
            int            *height,
            int            *row_stride,
            unsigned char **pixels);

/* do factor 2 decimation on the image data
 *
 * if some initial cropping is to be done, do it here
 */
void
downsize_to (int min_dim,
             int *width,
             int *height,
             int *row_stride,
             unsigned char **pixels);

#endif
