/* the options object is the object used to control the behavior
 * of comparisons done between digests, this is useful adjusting
 * weights etc,. switching between different backends when using
 * the options is hard, please use the (to be written) temp properties
 * alpha, beta, delta and gamma for testing.
 */

#ifndef _AKOIS_OPTIONS_H
#define _AKOIS_OPTIONS_H

typedef struct _akois_options  akois_options;

akois_options *
akois_options_new (void);

void
akois_options_free (akois_options *self);

void
akois_options_set_complexity (akois_options *self,
                              double         complexity);

double
akois_options_get_complexity (akois_options *self);


void
akois_options_set_depth (akois_options *self,
                         int            depth);

int
akois_options_get_depth (akois_options *self);

void
akois_options_set_neighbourhood (akois_options *self,
                                 int            neighbourhood);

int
akois_options_get_neighbourhood (akois_options *self);


void
akois_options_set_luminance (akois_options *self,
                             double         luminance);

double
akois_options_get_luminance (akois_options *self);

void
akois_options_set_chrominance (akois_options *self,
                               double         chrominance);

double
akois_options_get_chrominance (akois_options *self);

int
akois_options_get_results (akois_options *self);

void
akois_options_set_results (akois_options *self,
                           int            results);



void
akois_options_set_alpha (akois_options *self,
                         double         alpha);

double
akois_options_get_alpha (akois_options *self);


void
akois_options_set_beta (akois_options *self,
                        double         beta);

double
akois_options_get_beta (akois_options *self);


void
akois_options_set_gamma (akois_options *self,
                         double         gamma);

double
akois_options_get_gamma (akois_options *self);

void
akois_options_set_temporal_shadow (akois_options *self,
                               int            temporal_shadow); 

int
akois_options_get_temporal_shadow (akois_options *self);

#endif /* _AKOIS_OPTIONS_H */
